#!/usr/bin/env python
# coding=UTF-8
# 
# Copyright (C) 2010 Stefanos Harhalakis
#
# This file is part of wifieye.
#
# wifieye is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# wifieye is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with wifieye.  If not, see <http://www.gnu.org/licenses/>.
#
# $Id: 0.py 2265 2010-02-21 19:16:26Z v13 $

__version__ = "$Id: 0.py 2265 2010-02-21 19:16:26Z v13 $"

from PyQt4.QtCore import Qt, SIGNAL, QObject
from PyQt4.QtGui import QApplication, QDialog

try:
    _nope=Qt.WA_Maemo5AutoOrientation
    rotation=True
except:
    rotation=False

# 0: Initial / auto
# 1: Landscape
# 2: Portrait
curmode=0

orientator=None

def isPortrait0():
    g=QApplication.desktop().screenGeometry()
    if g.width()>g.height():
	ret=False
    else:
	ret=True
    return(ret)

def isPortrait():
    ret=isPortrait0()
#    if curmode==0:
#	ret=isPortrait0()
#    elif curmode==2:
#	ret=True
#    else:
#	ret=False

    return(ret)

class Orientator(QObject):
    """ Class to emit signals when mode changes (portrait/landscape) """
    def __init__(self):
	QObject.__init__(self)
	self.connect(QApplication.desktop(), SIGNAL('resized(int)'),
	    self._resized)

	self.oldmode=0

    def _resized(self, n):
	global curmode

	if isPortrait0():
	    curmode=2
	else:
	    curmode=1

	if curmode!=self.oldmode:
	    self.oldmode=curmode
	    self.emit(SIGNAL('orientationChanged(int)'), curmode)

def connectOrientationChange(slot):
    global orientator

    if orientator==None:
	orientator=Orientator()

    QObject.connect(orientator, SIGNAL('orientationChanged(int)'), slot)

class Portrait:
    def __init__(self):
	if not rotation:
	    print "norotation"
	    return

	self.setOrientationAuto()

    def setOrientationAuto(self):
	self.__setattr(Qt.WA_Maemo5AutoOrientation, True)

    def setOrientationPortrait(self):
	self.__setattr(Qt.WA_Maemo5PortraitOrientation, True)

    def setOrientationLandscape(self):
	self.__setattr(Qt.WA_Maemo5LandscapeOrientation, True)

    def __setattr(self, attr, value):
	if not rotation:
	    return
	self.setAttribute(attr, value)

# vim: set ts=8 sts=4 sw=4 noet formatoptions=r ai nocindent:

